Angular Grid: Components
You can create your own custom components to customise the behaviour of the grid. For example you can customise how cells are rendered, how values are edited and also create your own filters.
The full list of component types you can provide in AG Grid are as follows:
- Cell Renderer: To customises the contents of a cell.
- Cell Editor: To customises editing of a cell.
- Date Component: To customise the date selection component in the date filter.
- Filter Component: For custom column filter that appears inside the column menu.
- Floating Filter: For custom column filter that appears inside the column menu.
- Header Component: To customise the header of a column and column groups.
- Loading Cell Renderer: To customise the loading cell row when using Server Side row model.
- Overlay Component: To customise loading and no rows overlay components.
- Status Bar Component: For custom status bar components.
- Tool Panel Component: For custom tool panel components.
- Tooltip Component: For custom cell tooltip components.
The remainder of this page gives information that is common across all the component types.
Declaring Custom Components
In order for AG Grid to be able to use your Angular components, you need to provide them in
the top level NgModule
:
@NgModule({
imports: [
BrowserModule,
AgGridModule.withComponents(
[
SquareComponent, // Components to be used within the Grid
CubeComponent,
// ...other components
]
)
]
})
Registering Custom Components
The pages for each component type (cell renderer, cell editor etc) contain examples on how to register and use each component type. It is however useful here to step back and focus on the component registration process which is common across all component types.
There are two ways to register custom components:
- By name.
- Direct reference.
Both options are fully supported by the grid, however registering by name is AG Grid's preferred option as it's more flexible. All of the examples in the documentation use this approach. The direct reference approach is kept for backwards compatibility as this was the original way to do it in AG Grid.
1. By Name
When registering an Angular component by name you need to first register the component within the grid frameworkComponents
property,
then reference the component by name where you want it used (i.e. as a Cell Renderer, Filter etc).
In this example we've registered our CubeComponent
Angular Component and given it a name of cubeComponent
(this can be any name you choose).
We then specify that we want the previously registered cubeComponent
to be used as a Cell Renderer in the Cube
column:
//...other imports
import {Component} from '@angular/core';
import CubeComponent from './CubeComponent';
@Component({
selector: 'app-root',
template: `
<ag-grid-angular [frameworkComponents]="frameworkComponents" ...other properties>
</ag-grid-angular>
`
})
export class AppComponent {
frameworkComponents: [
'cubeComponent': CubeComponent
];
columnDefs: [
{
headerName: "Cube",
field: "value",
cellRenderer: 'cubeComponent',
}
]
//...other properties & methods
}
2. By Direct Reference
When registering an Angular Component by reference you simply pass the Component to the place you want it used (i.e. Cell Renderer, Filter etc).
In this example we're specifying that we want our CubeComponent
Angular Component as a Cell Renderer in the Cube
column:
//...other imports
import {Component} from '@angular/core';
import CubeComponent from './CubeComponent';
@Component({
selector: 'app-root',
template: `
<ag-grid-angular ...other properties>
</ag-grid-angular>
`
})
export class AppComponent {
columnDefs: [
{
headerName: "Cube",
field: "value",
cellRendererFramework: CubeComponent,
}
]
//...other properties & methods
}
When registering by Direct Reference you do not need to specify it in frameworkComponents
, but you lose future flexibility
if you decide for example to switch this component out for another.
Advantages of By Name
Registering components by name has the following advantages:
- Implementations can change without having to change all the column definitions. For example, you may have 20 columns using a currency cell renderer. If you want to update the cell renderer to another currency cell renderer, you only need to do it in only place (where the cell renderer is registered) and all columns will pick up the new implementation.
- The part of the grid specifying column definitions is plain JSON. This is helpful for applications that read column definitions from static data. If you referred to the class name directly inside the column definition, it would not be possible to convert the column definition to JSON.
Component Usage
The below table gives an overview of where components can be used. The table shows both options for usage:
-
Name / Direct JavaScript: This can be:
-
- A component name referring to a registered component (either plain JavaScript or an Angular Component);
-
- A direct reference to a JavaScript component.
-
- Direct Angular Reference: A direct reference to an Angular Component.
Component | Where | Name / Direct JavaScript | Direct Angular Reference |
---|---|---|---|
Detail Cell Renderer | Grid Option | detailCellRenderer | detailCellRendererFramework |
Full Width Cell Renderer | Grid Option | fullWidthCellRenderer | fullWidthCellRendererFramework |
Group Row Cell Renderer | Grid Option | groupRowRenderer | groupRowRendererFramework |
Group Row Inner Cell Renderer | Grid Option | groupRowInnerRenderer | groupRowInnerRendererFramework |
Loading Cell Renderer | Grid Option | loadingCellRenderer | loadingCellRendererFramework |
Loading Overlay | Grid Option | loadingOverlayRenderer | loadingOverlayRendererFramework |
No Rows Overlay | Grid Option | noRowsOverlayRenderer | noRowsOverlayRendererFramework |
Date Component | Grid Option | dateComponent | dateComponentFramework |
Status Bar Component | Grid Option -> Status Bar | statusPanel | statusPanelFramework |
Cell Renderer | Column Definition | cellRenderer | cellRendererFramework |
Pinned Row Cell Renderer | Column Definition | pinnedRowCellRenderer | pinnedRowCellRendererFramework |
Cell Editor | Column Definition | cellEditor | cellEditorFramework |
Filter | Column Definition | filter | filterFramework |
Floating Filter | Column Definition | floatingFilterComponent | floatingFilterComponentFramework |
Header Component | Column Definition | headerComponent | headerComponentFramework |
Header Group Component | Column Definition | headerGroupComponent | headerGroupComponentFramework |
Mixing JavaScript and Angular
When providing Custom Components have a choice of the following:
- Provide an AG Grid component in JavaScript.
- Provide an AG Grid component as an Angular Component.
For example if you want to build a cell renderer you have the choice to build the cell renderer using either Angular or using plain JavaScript.
The following code snippet shows how both JavaScript and Angular Components can be used at the same time:
//...other imports
import {Component} from '@angular/core';
import JavascriptComponent from './JavascriptComponent.js';
import AngularComponent from './AngularComponent';
@Component({
selector: 'app-root',
template: `
<ag-grid-angular [components]="components"
[frameworkComponents]="frameworkComponents"
...other properties>
</ag-grid-angular>
`
})
export class AppComponent {
// JavaScript components are registered here
components: [
'javascriptComponent': JavascriptComponent
];
// Angular components are registered here
frameworkComponents: [
'angularComponent': AngularComponent
];
columnDefs: [
{
headerName: "JS Cell",
field: "value",
cellRenderer: 'javascriptComponent', // reference/use the javascript component
},
{
headerName: "Angular Cell",
field: "value",
cellRenderer: 'angularComponent', // reference/use the Angular component
}
]
//...other properties & methods
}
Change the documentation view to JavaScript to see how to create a plain JavaScript component.
Grid Provided Components
The grid comes with pre-registered components that can be used. Each component provided by the grid starts with the namespaces 'ag' to minimise naming conflicts with user provided components. The full list of grid provided components are in the table below.
Date Inputs |
|
---|---|
agDateInput | Default date input used by filters. |
Column Headers |
|
agColumnHeader | Default column header. |
agColumnHeaderGroup | Default column group header. |
Column Filters |
|
agSetColumnFilter | Set filter (default when using AG Grid Enterprise). |
agTextColumnFilter | Simple text filter (default when using AG Grid Community). |
agNumberColumnFilter | Number filter. |
agDateColumnFilter | Date filter. |
Floating Filters |
|
agSetColumnFloatingFilter | Floating set filter. |
agTextColumnFloatingFilter | Floating text filter. |
agNumberColumnFloatingFilter | Floating number filter. |
agDateColumnFloatingFilter | Floating date filter. |
Cell Renderers |
|
agAnimateShowChangeCellRenderer | Cell renderer that animates value changes. |
agAnimateSlideCellRenderer | Cell renderer that animates value changes. |
agGroupCellRenderer | Cell renderer for displaying group information. |
agLoadingCellRenderer | Cell editor for loading row when using Enterprise row model. |
Overlays |
|
agLoadingOverlay | Loading overlay. |
agNoRowsOverlay | No rows overlay. |
Cell Editors |
|
agTextCellEditor | Text cell editor. |
agSelectCellEditor | Select cell editor. |
agRichSelectCellEditor |
Rich select editor. |
agPopupTextCellEditor | Popup text cell editor. |
agPopupSelectCellEditor | Popup select cell editor. |
agLargeTextCellEditor | Large text cell editor. |
Master Detail |
|
agDetailCellRenderer |
Detail panel for master / detail grid. |
Overriding Grid Components
It is also possible to override components. Where the grid uses a default value, this means the override component will be used instead. The default components, where overriding makes sense, are as follows:
- agDateInput: To change the default date selection across all filters.
- agColumnHeader: To change the default column header across all columns.
- agColumnGroupHeader: To change the default column group header across all columns.
- agLoadingCellRenderer: To change the default loading cell renderer for Enterprise Row Model.
- agLoadingOverlay: To change the default 'loading' overlay.
- agNoRowsOverlay: To change the default loading 'no rows' overlay.
- agTextCellEditor: To change the default text cell editor.
- agDetailCellRenderer: To change the default detail panel for master / detail grids.
- Components
- Declaring Custom Components
- "Inline" Components
- Locally Declared Components
- Externalised JavaScript Components (.js files)
- Externalised Single File Components (SFC / .vue files)
- Declaring Custom Components
- Registering Custom Components
- 1. By Name
- 2. Direct Reference
- Registering Custom Components
- 1. By Name
- 2. By Direct Reference
- Registering Custom Components
- 1. By Name
- 2. By Direct Reference
- Registering Custom Components
- Registering Inline Custom Components
- Registering Non-Inline Custom Components
- 1. By Name
- 2. By Direct Reference
- Advantages of By Name
- Advantages of By Name
- Advantages of By Name
- Component Usage
- Component Usage
- Component Usage
- Component Usage
- Mixing JavaScript and Angular
- Mixing JavaScript and React
- Mixing JavaScript and Vue
- Grid Provided Components
- Overriding Grid Components

Vue Data Grid

Custom Components

vue logo

You can create your own Custom Components to customise the behaviour of the grid. For example you can customise how cells are rendered, how values are edited and also create your own filters.

The full list of component types you can provide in the grid are as follows:

The remainder of this page gives information that is common across all the component types.

Declaring Custom Components

VueJS components can be defined as either simple inline components, or as full/complex externalised ones (i.e in a separate file).

"Inline" Components

export default {
  data() {
      return {
          ...data 
      }
  },
  components: {
      AgGridVue,              // the actual AgGridVue Grid component
      CubeComponent: {        // an inline custom component
          template: '<span>{{ valueCubed() }}</span>',
          methods: {
              valueCubed() {
                  return this.params.value * this.params.value * this.params.value;
              }
          }
      }
  }
}

Note here that we can define the property name either quoted or not but note that in order to reference these components in your column definitions you'll need to provide them as case-sensitive strings.

Locally Declared Components

const SquareComponent = {
   template: '<span>{{ valueSquared() }}</span>',
   methods: {
       valueSquared() {
           return this.params.value * this.params.value;
       }
   }
};

Externalised JavaScript Components (.js files)

// SquareComponent.js
export default {
   template: '<span>{{ valueSquared() }}</span>',
   methods: {
       valueSquared() {
           return this.params.value * this.params.value;
       }
   }
};

Externalised Single File Components (SFC / .vue files)

<template>
    <span class="currency">{{ params.value | currency('EUR') }}</span>
</template>

<script>
export default {
    filters: {
        currency(value, symbol) {
            let result = value;
            if (!isNaN(value)) {
                result = value.toFixed(2);
            }
            return symbol ? symbol + result : result;
        }
    }
};
</script>

<style scoped>
    .currency {
        color: blue;
    }
</style>

Note that in this case the component name will match the actual reference, but you can specify a different one if you choose:

components: {
    AgGridVue,
    'MySquareComponent': SquareComponent
}

All of the above works if you're going to register components by Name (see below). If you wish to register components by direct reference then you will need to wrap your component with Vue.extend(...your component...) (for Vue 2), or defineComponent(...your component...) (for Vue 3).

We highly recommend registration by name for the flexibility it provides - all of our examples use registration by name.

Registering Custom Components

The pages for each component type (cell renderer, cell editor etc) contain examples on how to register and use each component type. It is however useful here to step back and focus on the component registration process which is common across all component types.

There are generally two ways to register custom components ("inline" components can only be registered by name):

  • By name
  • Direct reference (deprecated)

Both options are fully supported by the grid - however we recommend referencing by name as registering by Direct Reference is deprecated. It's also the case that registering by name is the more flexible of the two options - given this, all of the examples in the documentation use registering by name. The direct reference approach is kept for backwards compatibility as this was the original way to do it in AG Grid.

Registering Inline Custom Components

Inline Custom Components can only be registered within the Grid by name:

<template>
  <ag-grid-vue :columnDefs="columnDefs" ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";

export default {
  components: {
      AgGridVue,
      CubeComponent: {
          template: '<span>{{ valueCubed() }}</span>',
          methods: {
              valueCubed() {
                  return this.params.value * this.params.value * this.params.value;
              }
          }
      }
  },
  data() {
      return {
          columnDefs: [
               {
                  headerName: "Cube",
                  field: "value",
                  cellRenderer: 'CubeComponent',     
              }
          ]
      }
  }
  //...other properties & methods
}
</script>

Registering Non-Inline Custom Components

1. By Name

To use a component within the grid you will reference components by case-sensitive name, for example:

<template>
  <ag-grid-vue ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";
import CubeComponent from './CubeComponent.vue';

export default {
  components: {
      AgGridVue,
      CubeComponent
  }
  data() {
      return {
          columnDefs: [
               {
                  headerName: "Cube",
                  field: "value",
                  cellRenderer: 'CubeComponent'     
              }
          ]
      }
  }
  //...other properties & methods
}
</script>

2. By Direct Reference

Deprecated.

This approach is supported but not recommend and will be removed in a future release.

When registering components within the Grid by direct reference the target components must be wrapped in Vue.extend(...) (for Vue 2), or defineComponent(...) (for Vue 3):

<template>
  <ag-grid-vue ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports
import Vue from "vue";
import {AgGridVue} from "ag-grid-vue3";

// component wrapped in Vue.extend for direct reference
const CubeComponent = Vue.extend({
  template: '<span>{{ valueCubed() }}</span>',
  methods: {
      valueCubed() {
          return this.params.value * this.params.value * this.params.value;
      }
  }
};


export default {
  components: {
      AgGridVue,
      // CubeComponent does not have to be registered here when registering by direct reference
  }
  data() {
      return {
          columnDefs: [
               {
                  headerName: "Cube",
                  field: "value",
                  cellRenderer: CubeComponent
              }
          ]
      }
  }
  //...other properties & methods
}
</script>

Advantages of By Name

Registering components by name has the following advantages:

  • Implementations can change without having to change all the column definitions. For example, you may have 20 columns using a currency cell renderer. If you want to update the cell renderer to another currency cell renderer, you only need to do it in only place (where the cell renderer is registered) and all columns will pick up the new implementation.
  • The part of the grid specifying column definitions is plain JSON. This is helpful for applications that read column definitions from static data. If you referred to the class name directly inside the column definition, it would not be possible to convert the column definition to JSON.
  • No need to wrap components with Vue.extend(...) / defineComponent(...)

Providing Additional Parameters

Each Custom Component gets a set of parameters from the grid. For example, for Cell Component the grid provides, among other things, the value to be rendered. You can provide additional properties to the Custom Component (e.g. what currency symbol to use) by providing additional parameters specific to your application.

To provide additional parameters, use the property [prop-name]Params, e.g. cellRendererParams.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { 
        field: 'price',
        cellRenderer: PriceCellRenderer,
        cellRendererParams: {
            currency: 'EUR'
        }
    },
];

Mixing JavaScript and Vue

When providing Custom Components you have a choice of the following:

  1. Provide an AG Grid component in JavaScript.
  2. Provide an AG Grid component as an Vue Component.

For example if you want to build a cell renderer you have the choice to build the cell renderer using either Vue or using plain JavaScript.

The following code snippet shows how both JavaScript and Vue Components can be used at the same time:

<template>
  <ag-grid-vue :components="components" 
               ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";
import JavascriptComponent from './JavascriptComponent.js';
import VueComponent from './VueComponent.vue';

export default {
  components: {
      AgGridVue,
      // Vue components are registered here
      'vueComponent': VueComponent
  }
  data() {
      return {
          // JavaScript components are registered here, for when looking up component by name
          components: {
              // declare the javascript component
              'javascriptComponent': JavascriptComponent
          },          
          columnDefs: [
               {
                  headerName: "JS Cell",
                  field: "value",
                  cellRenderer: 'javascriptComponent',    // reference/use the javascript component by name
              },
               {
                  headerName: "JS Cell",
                  field: "value",
                  cellRenderer: JavascriptComponent,    // reference/use the javascript component directly
              },
              {
                  headerName: "Vue Cell",
                  field: "value",
                  cellRenderer: 'vueComponent',  // reference/use the Vue component
              }
          ]
      }
  }
  //...other properties & methods
}
</script>

Change the documentation view to JavaScript to see how to create a plain JavaScript component.

Child to Parent Communication

There are a variety of ways to manage component communication in Vue (shared service, local variables etc), but you often need a simple way to let a "parent" component know that something has happened on a "child" component. In this case the simplest route is to use the Grid's context feature to hold a reference to the parent, which the child can then access.

// Parent Grid Component
<template>
  <ag-grid-vue :context="context" ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";
import CubeComponent from './CubeComponent.vue';

export default {
  components: {
      AgGridVue
  }
  data() {
      return {
          context: {}
      }
  },
  beforeMount() {
      this.context = {
          componentParent: this
      }
  },
  methods: {
      parentMethod() {
          // do something
      }
  }
  //...other properties & methods
}
</script>

// Child Grid Component
<template>
  <ag-grid-vue ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports

export default {
  methods: {
      doSomethingOnGrid() {
          // the grid component can now be accessed via this.params.context.componentParent
          this.params.context.componentParent.parentMethod()
      }
  }
  //...other properties & methods
}
</script>

Note that although we've used componentParent as the property name here it can be anything - the main point is that you can use the context mechanism to share information between the components.

A working example of this can be found in the Cell Renderer docs.

Provide/Inject

When using Vue Components within AG Grid you are able to use provide / context, but only in the Options format below:

// Parent Grid
const VueExample = {
   template: `
       <ag-grid-vue
               style="width: 100%; height: 100%;"
               class="ag-theme-quartz"
               :columnDefs="columnDefs"
               :rowData="rowData">
       </ag-grid-vue>
   `,
   components: {
       'ag-grid-vue': AgGridVue,
       'myRenderer': MyRenderer
   },
   provide: {
       'providedValue': 'testValue' // provide this value to grid components
   },

   //...rest of the component definition
}

// Child Grid Component
export default {
   name: 'myRenderer',
   template: `<span>{{ value }} {{ test }}</span>`,
   inject: ['providedValue'],   // retrieve/inject the provided value
   
   //...rest of the component definition
};

You cannot use the new Composition API (inject/provide) as this is not supported by Vue when using createNode createVNode, but the above is a workable alternative.

Alternatively you could consider using the Grid's Context mechanism to share data with child components.

Component Usage

The below table gives a summary of the components, where they are configured and using what attribute.

ComponentWhereAttribute
Cell ComponentColumn DefinitioncellRenderer
cellRendererParams
cellRendererSelector
Editor ComponentColumn DefinitioncellEditor
cellEditorParams
cellEditorSelector
FilterColumn Definitionfilter
filterParams
Floating FilterColumn DefinitionfloatingFilter
floatingFilterParams
Header ComponentColumn DefinitionheaderComponent
headerComponentParams
Header Group ComponentColumn DefinitionheaderGroupComponent
headerGroupComponentParams
Tooltip ComponentColumn DefinitiontooltipComponent
tooltipComponentParams
Group Row Cell ComponentGrid OptiongroupRowRenderer
groupRowRendererParams
Group Row Inner Cell ComponentGrid OptioninnerRenderer
innerRendererParams
Detail Cell ComponentGrid OptiondetailCellRenderer
detailCellRendererParams
Full Width Cell ComponentGrid OptionfullWidthCellRenderer
fullWidthCellRendererParams
Loading Cell ComponentGrid OptionloadingCellRenderer
loadingCellRendererParams
Loading OverlayGrid OptionloadingOverlayComponent
loadingOverlayComponentParams
No Rows OverlayGrid OptionnoRowsOverlayComponent
noRowsOverlayComponentParams
Date ComponentGrid OptiondateComponent
dateComponentParams
Status Bar ComponentGrid Option -> Status BarstatusPanel
statusPanelParams
Tool PanelGrid Option -> Side BartoolPanel
toolPanelParams
Menu ItemGrid Option -> MenumenuItem
menuItemParams

Grid Provided Components

The grid comes with pre-registered components that can be used. Each component provided by the grid starts with the namespaces 'ag' to minimise naming conflicts with user provided components. The full list of grid provided components are in the table below.

Date Inputs
agDateInputDefault date input used by filters
Column Headers
agColumnHeaderDefault column header
agColumnHeaderGroupDefault column group header
Column Filters
agSetColumnFilter (e)Set filter (default when using AG Grid Enterprise)
agTextColumnFilterSimple text filter (default when using AG Grid Community)
agNumberColumnFilterNumber filter
agDateColumnFilterDate filter
agMultiColumnFilter (e)Multi filter
agGroupColumnFilter (e)Group column filter
Floating Filters
agSetColumnFloatingFilter (e)Floating set filter
agTextColumnFloatingFilterFloating text filter
agNumberColumnFloatingFilterFloating number filter
agDateColumnFloatingFilterFloating date filter
agMultiColumnFloatingFilter (e)Floating multi filter
agGroupColumnFloatingFilter (e)Floating group column filter
Cell Components
agAnimateShowChangeCellRendererCell Component that animates value changes
agAnimateSlideCellRendererCell Component that animates value changes
agGroupCellRendererCell Component for displaying group information
agLoadingCellRenderer (e)Cell Component for loading row when using Enterprise row model
agCheckboxCellRendererCell Component that displays a checkbox for boolean values
Overlays
agLoadingOverlayLoading overlay
agNoRowsOverlayNo rows overlay
Cell Editors
agTextCellEditorText cell editor
agSelectCellEditorSelect cell editor
agRichSelectCellEditor (e)Rich select editor
agLargeTextCellEditorLarge text cell editor
agNumberCellEditorNumber cell editor
agDateCellEditorDate cell editor
agDateStringCellEditorDate represented as string cell editor
agCheckboxCellEditorCheckbox cell editor
Master Detail
agDetailCellRenderer (e)Detail panel for master / detail grid
Column Menu / Context Menu
agMenuItem (e)Menu item within column or context menu

Overriding Grid Components

It is also possible to override components. Where the grid uses a default value, this means the override component will be used instead. The default components, where overriding makes sense, are as follows:

  • agDateInput: To change the default date selection across all filters.
  • agColumnHeader: To change the default column header across all columns.
  • agColumnGroupHeader: To change the default column group header across all columns.
  • agLoadingCellRenderer: To change the default loading cell renderer for Enterprise Row Model.
  • agLoadingOverlay: To change the default 'loading' overlay.
  • agNoRowsOverlay: To change the default loading 'no rows' overlay.
  • agCellEditor: To change the default cell editor.
  • agDetailCellRenderer: To change the default detail panel for master / detail grids.
  • agMenuItem: To change the default menu item for column and context menus.

To override the default component, register the custom component in the GridOptions components property under the above name.

const MyApp = {
   // Here is where we specify the components to be used instead of the default
   components: {
       'ag-grid-vue': AgGridVue
       agDateInput: CustomDateComponent,
       agColumnHeader: CustomHeaderComponent
   },

Overridable grid components are the only components you need to additionally specify with components in order to tie their usage to the actual component. All other registration types specify their usage in column definitions or on the AgGridVue component itself.

For an example of this please refer to the Date Component documentation.

AG Studio: Build dashboards using native components in web apps. Join us for a webinar on 28th July at 2pm UTC+1 Register

React Data GridCustom Components

You can create your own Custom Components to customise the behaviour of the grid. For example you can customise how cells are rendered, how values are edited and also create your own filters.

React Custom Components thumbnail

The full list of component types you can provide in the grid are as follows:

The remainder of this page gives information that is common across all the component types.

Registering Custom Components Copy Link

In versions <= v31, custom components were declared in an imperative way. See Migrating to Use reactiveCustomComponents for details on how to migrate to the current format.

There are two ways to register custom components:

  • Direct reference.
  • By name.

1. By Direct Reference Copy Link

When registering a React Component by reference you simply pass the Component to the place you want it used (i.e. Cell Renderer, Filter etc).

In this example we're specifying that we want our React CubeComponent as a Cell Renderer in the Cube column:

//...other imports
import CubeComponent from './CubeComponent';

const GridExample = () => {
  // other properties & methods

    const columnDefs = useMemo( () => [{field: 'value', cellRenderer: CubeComponent}], []);

    return (
        <AgGridReact
            columnDefs={columnDefs}
            ...other properties
        />
    );
};

The advantage of referencing Components directly is cleaner code, without the extra level of indirection added when referencing by name.

2. By Name Copy Link

When registering a React component by name you need to first register the component within the grid components property, then reference the component by name where you want it used (i.e. as a Cell Renderer, Filter etc).

In this example we've registered our React CubeComponent and given it a name of cubeComponent (this can be any name you choose). We then specify that we want the previously registered cubeComponent to be used as a Cell Renderer in the Cube column:

//...other imports
import CubeComponent from './CubeComponent';

const GridExample = () => {
  // other properties & methods

  const components = useMemo(() => ({
      cubeComponent: CubeComponent
  }), []);

  const columnDefs = useMemo(() => [{field: 'value', cellRenderer: 'cubeComponent'}], []);

  return (
        <AgGridReact
           components={components}
           columnDefs={columnDefs}
           ...other properties
        />
  );
};

The advantage of referencing components by name is definitions (eg Column Definitions) can be composed of simple types (ie JSON), which is useful should you wish to persist Column Definitions.

A React Component in this context can be any valid React Component - A Class Based Component, a Hook or even an inline Functional Component. The same rules apply regardless of the type of component used.

Clicking on the Push For Total button will log results in the developer console.

Providing Additional Parameters Copy Link

Each Custom Component gets a set of parameters from the grid. For example, for Cell Component the grid provides, among other things, the value to be rendered. You can provide additional properties to the Custom Component (e.g. what currency symbol to use) by providing additional parameters specific to your application.

To provide additional parameters, use the property [prop-name]Params, e.g. cellRendererParams.

const [columnDefs, setColumnDefs] = useState([
    {
        field: 'price',
        cellRenderer: PriceCellRenderer,
        cellRendererParams: {
            currency: 'EUR'
        }
    },
]);

<AgGridReact columnDefs={columnDefs} />

Mixing JavaScript and React Copy Link

When providing Custom Components you have a choice of the following:

  1. Provide an AG Grid component as a React Component.
  2. Provide an AG Grid component in JavaScript (JavaScript Class Components only, not JavaScript Functional Components).

The following code snippet shows how both JavaScript and React Components can be used at the same time:

//...other imports
import JavascriptComponent from './JavascriptComponent.js';
import ReactComponent from './ReactComponent';

const GridExample = () => {
  // JS and React components, only need register if looking up by name
  const components = useMemo(() => ({
      'javascriptComponent': JavascriptComponent,
      'reactComponent': ReactComponent
  }), []);

  const columnDefs = useMemo( () => [
      {
          headerName: "JS Cell",
          field: "value",
          cellRenderer: 'javascriptComponent', // JS comp by Name
      },
      {
          headerName: "JS Cell",
          field: "value",
          cellRenderer: JavascriptComponent, // JS comp by Direct Reference
      },
      {
          headerName: "React Cell",
          field: "value",
          cellRenderer: 'reactComponent', // React comp by Name
      },
      {
          headerName: "React Cell",
          field: "value",
          cellRenderer: ReactComponent, // React comp by Direct Reference
      }
  ], []);

    return (
        <AgGridReact
            components={components}
            columnDefs={columnDefs}
            ...other properties
        />
    );
};

Change the documentation view to JavaScript to see how to create a plain JavaScript component.

Higher Order Components Copy Link

If you use connect to use Redux, or if you're using a Higher Order Component (HOC) to wrap the grid React component, you'll also need to ensure the grid can get access to the newly created component. To do this you need to ensure forwardRef is set:

export default connect((state) => {
    return {
        currencySymbol: state.currencySymbol,
        exchangeRate: state.exchangeRate
    }
}, null, null, { forwardRef: true } // must be supplied for react/redux when using AgGridReact
)(PriceRenderer);

Component Usage Copy Link

The below table gives a summary of the components, where they are configured and using what attribute.

ComponentWhereAttribute
Cell ComponentColumn DefinitioncellRenderer
cellRendererParams
cellRendererSelector
Editor ComponentColumn DefinitioncellEditor
cellEditorParams
cellEditorSelector
FilterColumn Definitionfilter
filterParams
Floating FilterColumn DefinitionfloatingFilter
floatingFilterParams
Date ComponentColumn DefinitiondateComponent
dateComponentParams
Header ComponentColumn DefinitionheaderComponent
headerComponentParams
Inner Header ComponentColumn DefinitioninnerHeaderComponent
innerHeaderComponentParams
Header Group ComponentColumn DefinitionheaderGroupComponent
headerGroupComponentParams
Inner Header Group ComponentColumn DefinitioninnerHeaderGroupComponent
innerHeaderGroupComponentParams
Tooltip ComponentColumn DefinitiontooltipComponent
tooltipComponentParams
Group Row Cell ComponentGrid OptiongroupRowRenderer
groupRowRendererParams
Group Row Inner Cell ComponentcellRendererParams
groupRowRendererParams
innerRenderer
innerRendererParams
Detail Cell ComponentGrid OptiondetailCellRenderer
detailCellRendererParams
Full Width Cell ComponentGrid OptionfullWidthCellRenderer
fullWidthCellRendererParams
Loading Cell ComponentGrid Option
Column Definition
loadingCellRenderer
loadingCellRendererParams
Overlay ComponentGrid OptionoverlayComponent
overlayComponentParams
overlayComponentSelector
Active OverlayGrid OptionactiveOverlay
activeOverlayParams
Drag and Drop ImageGrid OptiondragAndDropImageComponent
dragAndDropImageComponentParams
Status Bar ComponentGrid Option -> Status BarstatusPanel
statusPanelParams
Tool PanelGrid Option -> Side BartoolPanel
toolPanelParams
Toolbar Item ComponentGrid Option -> ToolbartoolbarItem
toolbarItemParams
Menu ItemGrid Option -> MenumenuItem
menuItemParams

Grid Provided Components Copy Link

The grid comes with pre-registered components that can be used. Each component provided by the grid starts with the namespaces 'ag' to minimise naming conflicts with user provided components. The full list of grid provided components are in the table below.

Drag And Drop
agDragAndDropImageDefault cover element when grid parts are being dragged
Date Inputs
agDateInputDefault date input used by filters
Column Headers
agColumnHeaderDefault column header
agColumnHeaderGroupDefault column group header
Column Filters
agSetColumnFilter (e)Set filter (default when using AG Grid Enterprise)
agTextColumnFilterSimple text filter (default when using AG Grid Community)
agNumberColumnFilterNumber filter
agDateColumnFilterDate filter
agMultiColumnFilter (e)Multi filter
agGroupColumnFilter (e)Group column filter
Floating Filters
agSetColumnFloatingFilter (e)Floating set filter
agTextColumnFloatingFilterFloating text filter
agNumberColumnFloatingFilterFloating number filter
agDateColumnFloatingFilterFloating date filter
agMultiColumnFloatingFilter (e)Floating multi filter
agGroupColumnFloatingFilter (e)Floating group column filter
Cell Components
agAnimateShowChangeCellRendererCell Component that animates value changes
agAnimateSlideCellRendererCell Component that animates value changes
agGroupCellRendererCell Component for displaying group information
agLoadingCellRenderer (e)Cell Component for loading row when using Enterprise row model
agSkeletonCellRendererCell Component for displaying skeleton cells
agCheckboxCellRendererCell Component that displays a checkbox for boolean values
Overlays
agLoadingOverlayLoading overlay
agNoRowsOverlayNo rows overlay
agNoMatchingRowsOverlayNo matching rows overlay
agExportingOverlayExporting overlay
Cell Editors
agTextCellEditorText cell editor
agSelectCellEditorSelect cell editor
agRichSelectCellEditor (e)Rich select editor
agLargeTextCellEditorLarge text cell editor
agNumberCellEditorNumber cell editor
agDateCellEditorDate cell editor
agDateStringCellEditorDate represented as string cell editor
agCheckboxCellEditorCheckbox cell editor
Master Detail
agDetailCellRenderer (e)Detail panel for master / detail grid
Column Menu / Context Menu
agMenuItem (e)Menu item within column or context menu

Overriding Grid Components Copy Link

It is also possible to override components. Where the grid uses a default value, this means the override component will be used instead. The default components, where overriding makes sense, are as follows:

  • agDragAndDropImage: To change the default drag and drop image when dragging grid parts.
  • agDateInput: To change the default date selection across all filters.
  • agColumnHeader: To change the default column header across all columns.
  • agColumnGroupHeader: To change the default column group header across all columns.
  • agLoadingCellRenderer: To change the default loading cell renderer for Enterprise Row Model.
  • agSkeletonCellRenderer: To change the default skeleton loading cell renderer for Enterprise Row Model.
  • agLoadingOverlay: To change the default 'loading' overlay.
  • agNoRowsOverlay: To change the default 'no rows' overlay.
  • agNoMatchingRowsOverlay: To change the default 'no matching rows' overlay.
  • agExportingOverlay: To change the default 'exporting' overlay.
  • agCellEditor: To change the default cell editor.
  • agDetailCellRenderer: To change the default detail panel for master / detail grids.
  • agMenuItem: To change the default menu item for column and context menus.
  • agTooltipComponent: To change the default tooltip component for all tooltips.

To override the default component, register the custom component in the GridOptions components property under the above name.

const components = useMemo(() => (
    { agDateInput: CustomDateComponent,
        agColumnHeader: CustomHeaderComponent
    }), []);

<AgGridReact
    components={components}
    ...other properties...
/>